---
title: Incremental builds with filesystem watching
slug: >-
  Mozilla/Developer_guide/Build_Instructions/Incremental_builds_with_filesystem_watching
tags:
  - Artifact builds
  - Build documentation
  - Developing Mozilla
  - Firefox
---
<div class="note">
<p>Note: This page covers required steps to incrementally update a bleeding-edge, development version of <strong>Firefox for Desktop</strong>. We use <a href="https://facebook.github.io/watchman/">watchman</a> to monitor filesystem changes and automatically generate the changed build outputs.<br>
 <br>
 If you're having difficulty following this documentation, or hit a roadblock, please contact:</p>

<ul>
 <li>Nick Alexander at <a class="link-mailto" href="mailto:nalexander@mozilla.com" rel="freelink">nalexander@mozilla.com</a></li>
 <li>Brian Grinstead at <a class="link-mailto" href="mailto:bgrinstead@mozilla.com" rel="freelink">bgrinstead@mozilla.com</a></li>
</ul>

<p>This not only helps us solving your difficulty, but often those who come after you.  For more information, see the general Firefox <a class="internal" href="/en-US/docs/Mozilla/Developer_guide/Build_Instructions" title="/en-US/docs/Developer_Guide/Build_Instructions">build documentation</a>.</p>
</div>

<h2 id="Incremental_builds_with_filesystem_watching">Incremental builds with filesystem watching</h2>

<p>Firefox for Desktop supports a fast build build modem called <a href="/docs/Artifact_builds">artifact mode</a>.  When you're using artifact mode, you can opt-in to an <strong>even faster incremental front-end build process</strong>.</p>

<h2 id="Prerequisites">Prerequisites</h2>

<p>You must:</p>

<ul>
 <li>Be using <a href="/docs/Artifact_builds">artifact builds.</a></li>
 <li>Be building Firefox for Desktop.</li>
 <li>Have successfully built Firefox for Desktop.</li>
 <li>Have <a href="https://facebook.github.io/watchman/">watchman</a> installed.</li>
</ul>

<h2 id="Installing_pywatchman">Installing pywatchman</h2>

<p>Incremental front-end builds require the <code>pywatchman</code> wrapper around <code>watchman</code> to be installed.  To verify that you have <code>watchman</code> installed, ensure that <code>watchman --version</code> succeeds.</p>

<p>Most Desktop developers on Mac OS X or Linux should find:</p>

<pre>./mach watch
</pre>

<p>just works.  This incrementally rebuilds local JS, CSS, and packaged files, including images.</p>

<p>Windows developers may have a more difficult time.  We're working on smoothing out the kinks for Windows developers, and would appreciate working through problems with you.</p>

<h2 id="Quick_Restart_workflow">Quick Restart workflow</h2>

<p><code>mach watch</code> and the <a href="https://searchfox.org/mozilla-central/rev/b9f1a4ecba48b2d8c686669e32d109c40e927b48/browser/base/content/browser-development-helpers.js#26">developer-only Quick Restart key binding</a> reduces the time of each edit-compile-run cycle.  In a terminal, run</p>

<pre>./mach build # (Capture changes to the build system -- only needed once!)
./mach watch</pre>

<p>And in a second terminal, run</p>

<pre>./mach run</pre>

<p>Here's an example of using Quick Restart to replace the current browser process with one reflecting changes to <code>browser/components/customizableui/CustomizeMode.jsm</code>:</p>

<p><img alt="Screen capture that shows using Quick Restart to replace the current browser process with one reflecting changes to browser/components/customizableui/CustomizeMode.jsm" src="https://mdn.mozillademos.org/files/15803/Quick%20restart%20flow.gif" style="height: 783px; width: 1406px;"></p>

<h2 id="Restrictions">Restrictions</h2>

<h3 id="Things_that_are_supported">Things that are supported</h3>

<ul>
 <li>Modifying JavaScript, (X)HTML, CSS resources, string properties and DTD files.</li>
</ul>

<p>Most things updated by <code>mach build faster</code> should also work with <code>mach watch</code>.</p>

<h3 id="Things_not_supported">Things not supported</h3>

<ul>
 <li>Modifying build system configuration and definitions, including <code>moz.build</code> definitions and <code>jar.mn</code> manifests.  Kill <code>mach watch</code>, run <code>mach build faster</code> to pick up the changes to the build system itself, and restart <code>mach watch</code>.</li>
</ul>

<h2 id="Troubleshooting">Troubleshooting</h2>

<p>Discussion are best started on the <a href="https://lists.mozilla.org/listinfo/dev-builds">dev-builds mailing list</a>.  Raise questions in #build on <a href="https://wiki.mozilla.org/IRC">IRC</a>.  File bugs in <em>Core :: Build Config</em>, blocking {{ Bug("1384241") }}.</p>
